<!-- The AddResponse.lasso page is similar to the Display.lasso page, but performs an -Add action instead of a -Search action in the opening [Inline] tag so that a record is added based on information submitted in a preceding form. -->

[Auth]

[Include:'header.lasso']

<form action="undefined" method="POST">
	<table bgcolor="#FFFFFF" cellspacing="1" cellpadding="5" width="550" border="0">
		<tr>
			<td colspan="2"> <h2>Add Response</b></h2>
			
	<!-- The [Inline] LDML object adds a record to the database. The [Action_Params] tag transfers all information submitted from a previous page. -->		
			
	[Inline: (Action_Params), -Database='Example_DB', -Table='web', -KeyField='id', -Add]
 </td>
		</tr>
		<tr>
			<td colspan="2"> 	
			
			<!-- An [If] statement is used to display an error message if an error occurs when adding the record. The [Error_CurrentError] tag displays the current Lasso error message. For more information on error tags, see Chapter 21 in the Lasso 7 Language Guide. -->
			
			[If: (Error_CurrentError) != (Error_NoError)]An error has occurred. ([Error_CurrentError: -ErrorCode] [Error_CurrentError])[/If]
	[/Inline]
 </td>
		</tr>
		
		<!-- Record data is displayed via [Action_Param] LDML objects, which display the values submitted in the preceding form that were added to the database. -->
		
		<tr>
			<td> id </td>
			<td> [Action_Param: 'id'] </td>
		</tr>
		<tr>
			<td> address </td>
			<td> [Action_Param: 'address'] </td>
		</tr>
		<tr>
			<td> city </td>
			<td> [Action_Param: 'city'] </td>
		</tr>
		<tr>
			<td> company </td>
			<td> [Action_Param: 'company'] </td>
		</tr>
		<tr>
			<td> description </td>
			<td> [Action_Param: 'description'] </td>
		</tr>
		<tr>
			<td> phone </td>
			<td> [Action_Param: 'phone'] </td>
		</tr>
		<tr>
			<td> state </td>
			<td> [Action_Param: 'state'] </td>
		</tr>
		<tr>
			<td> url </td>
			<td> [Action_Param: 'url'] </td>
		</tr>
		<tr>
			<td> zip </td>
			<td> [Action_Param: 'zip'] </td>
		</tr>
		<tr>
			<td> country </td>
			<td> [Action_Param: 'country'] </td>
		</tr>
		<tr>
			<td colspan="2">  </td>
		</tr>
	</table>
</form>

[Include:'footer.lasso']
