<?LassoScript

//
// Variables
//

_admin_addvar: 'datasource_action', -default='None', -override=(action_param: 'datasource_action', (action_param: 'datasource_action', -count));
_admin_addvar: 'datasource_actionraw', -default='None', -override=(action_param: 'datasource_action');
_admin_addvar: 'datasource_connector_skip', -default=1, -session='_admin', -override=(action_param: 'datasource_connector_skip');
_admin_addvar: 'datasource_navigation', -override=(action_param: 'datasource_navigation');
_admin_addvar: 'datasource_jump', -override=(action_param: 'datasource_jump');

_admin_addvar: 'dialog_action', -override=(action_param: 'dialog_action');

_admin_addvar: 'connector_enabled', -override=(action_param: 'connector_enabled');
_admin_addvar: 'connector_name', -override=(action_param: 'connector_name');


//
// Process Action
//

if: $datasource_action >> 'Update';

	_admin_updateconnector: $datasource_connectorid, 'enabled'=$connector_enabled;
	if: $_code != (error_noerror);
		var: 'datasource_error' = $_error + ' (' + $_code + ')';
	else;
		var: 'datasource_message' = 'The connector was updated successfully.';
	/if;

	// Store friendly connector name
	var: 'temp_name' = $datasource_connectordetail->(find: 'name');
	if: ($temp_name != 'mysqlds') && ($temp_name != 'internalmysqlds') && ($temp_name != 'fmremotedatasource') && ($temp_name != 'fmserveradvanceddatasource');
		inline: -search, 
				-database='lasso_internal', 
				-table='global_prefs',
				-keyfield='store_key',
				-keyvalue='_admin_connector_alias:' + $temp_name,
				-maxrecords=1;
			if: (found_count == 1);
				inline: -update, 
						-database='lasso_internal', 
						-table='global_prefs',
						-keyfield='store_key',
						-keyvalue='_admin_connector_alias:' + $temp_name,
						'data' = $connector_name;
				/inline;
			else;
				inline: -add, 
						-database='lasso_internal', 
						-table='global_prefs',
						-keyfield='store_key',
						'store_key' = '_admin_connector_alias:' + $temp_name,
						'data' = $connector_name;
				/inline;
			/if;
		
		/inline;
	/if;
	
	var: '__admin_connectors_array' = null;
	var: 'datasource_connectormap' = (_admin_listconnectors);
	var: 'datasource_connectordetail' = $datasource_connectormap->(find: $datasource_connectorid)->(get:1)->second;
	var: 'datasource_action' = 'Detail';

else: $datasource_action >> 'Add Host';

	// Redirect
	var: 'link' = $admin_link + '&tab3=host' +
		'&datasource_connectorid=' + $datasource_connectorid +
		'&datasource_action=Add+Host';
	redirect_url: $link;
	output: '<a href="' + $link + '">' + $link + '</a>', -encodenone;
	abort;

else: $dialog_action >> 'Delete';

	_admin_deleteconnector: $datasource_connectorid;

	var: '__admin_connectors_array' = null;
	_admin_refreshsecurity;

	var: 'datasource_connectormap' = (_admin_listconnectors);
	var: 'datasource_connectorid' = 0;

	var: 'datasource_action' = 'Refresh';

else: $datasource_action >> 'List Hosts';

	// Redirect
	var: 'link' = $admin_link + '&tab3=host' +
		'&datasource_connectorid=' + $datasource_connectorid;
	redirect_url: $link;
	output: '<a href="' + $link + '">' + $link + '</a>', -encodenone;
	abort;

else: $datasource_action >> 'List Databases';

	// Redirect
	var: 'link' = $admin_link + '&tab3=databases' +
		'&datasource_connectorid=' + $datasource_connectorid +
		'&datasource_hostid=' + $datasource_hostid;
	redirect_url: $link;
	output: '<a href="' + $link + '">' + $link + '</a>', -encodenone;
	abort;

/if;


//
// Process Navigation
//

if: $datasource_navigation >> 'Prev';
	$datasource_connector_skip -= 10;
else: $datasource_navigation >> 'Next';
	$datasource_connector_skip += 10;
else: $datasource_navigation >> 'First';
	$datasource_connector_skip = 1;
else: $datasource_navigation >> 'Last';
	$datasource_connector_skip = $datasource_connectormap->size - (($datasource_connectormap->size - 1) % 10);
else: $datasource_navigation >> 'Jump';
	$datasource_connector_skip = integer: $datasource_jump;
/if;

var: 'found_count' = $datasource_connectormap->size;
var: 'datasource_connector_skip' = integer: (math_max: 1, (math_min: $datasource_connector_skip, $found_count));
var: 'shown_first' = $datasource_connector_skip;
var: 'shown_last' = integer: (math_min: $found_count, $datasource_connector_skip + 9);
var: 'shown_count' = ($shown_last - $shown_first + 1);


//
// Count hosts for each connector
//

var: 'datasource_connectorlisthosts' = array;

inline: -database='lasso_internal', -sql='SELECT DISTINCT id_datasource FROM security_datasource_hosts';
	records;
		$datasource_connectorlisthosts->(insert: (field: 'id_datasource'));
	/records;
/inline;

?>
