<?LassoScript

//
// Variables
//

_admin_addvar: 'search_connectorid', -default='any', -session='_admin', -override=(action_param: 'search_connectorid');
_admin_addvar: 'search_hostid', -default='any', -session='_admin', -override=(action_param: 'search_hostid');
_admin_addvar: 'search_databaseid', -default='any', -session='_admin', -override=(action_param: 'search_databaseid');

_admin_addvar: 'search_action', -default='None', -override=(action_param: 'search_action', (action_param: 'search_action', -count));
_admin_addvar: 'search_actionraw', -default='None', -override=(action_param: 'search_action');
_admin_addvar: 'datasource_search_skip', -default=1, -session='_admin', -override=(action_param: 'datasource_search_skip');
_admin_addvar: 'search_navigation', -override=(action_param: 'search_navigation');
_admin_addvar: 'search_jump', -override=(action_param: 'search_jump');

_admin_addvar: 'search_name', -session='_admin', -override=(action_param: 'search_name');
_admin_addvar: 'search_alias', -session='_admin', -override=(action_param: 'search_alias');
_admin_addvar: 'search_status', -default='any', -session='_admin', -override=(action_param: 'search_status');
_admin_addvar: 'search_username', -session='_admin', -override=(action_param: 'search_username');

_admin_addvar: 'dialog_action', -default='None', -override=(action_param: 'dialog_action');

_admin_addvar: 'search_databasemap', -session='_admin';

//
// Process Action
//

if: $dialog_action >> 'Delete All Settings';

	iterate: $search_databasemap, (var: 'temp_database');
		var: 'temp_tables' = (_admin_listtables: $temp_database->first);
		iterate: $temp_tables, (var: 'temp_table');
			var: 'temp_map' = (_admin_listfields: $temp_table->first);
			iterate: $temp_map, (var: 'temp_field');
				_admin_deletefield: $temp_field->first;
			/iterate;
			_admin_deletetable: $temp_table->first;
		/iterate;
		_admin_deletedatabase: $temp_database->first;
	/iterate;

	var: 'search_databasemap' = null;

else: $dialog_action >> 'Enable All New';

	iterate: $search_databasemap, (var: 'temp_database');
		var: 'id' = $temp_database->first;
		var: 'detail' = $temp_database->second;
		if: $detail->(find: 'status') == 'New';
			_admin_updatedatabase: $id, 'enabled'='Y';
		/if;
	/iterate;

	var: 'search_databasemap' = null;

else: $dialog_action >> 'Enable All';

	iterate: $search_databasemap, (var: 'temp_database');
		var: 'id' = $temp_database->first;
		_admin_updatedatabase: $id, 'enabled'='Y';
	/iterate;

	var: 'search_databasemap' = null;

else: $dialog_action >> 'Disable All';

	iterate: $search_databasemap, (var: 'temp_database');
		var: 'id' = $temp_database->first;
		_admin_updatedatabase: $id, 'enabled'='N';
	/iterate;

	var: 'search_databasemap' = null;

/if;


if: $search_action >> 'Reset';

	var: 'search_databasemap' = null;
	var: 'search_name' = '';
	var: 'search_alias' = '';
	var: 'search_status' = 'any';
	var: 'search_username' = '';
	var: 'search_connectorid' = 'any';
	var: 'search_hostid' = 'any';
	var: 'search_databaseid' = 'any';

else: ($search_action >> 'Search') || ($search_action >> 'Find All');

	local: 'search_databasemap' = (array);
	local: 'search_inline' = (array);

	if: ($search_action >> 'Find All');

		$search_inline->(insert: -findall='');
		$search_inline->(insert: -sortfield='name');

	else;

		$search_inline->(insert: -search='');
		$search_inline->(insert: -sortfield='name');

		if: $search_connectorid != 'any';
			$search_inline->(insert: -op='eq');
			$search_inline->(insert: 'id_connector'=$search_connectorid);
		/if;
		if: $search_hostid != 'any';
			$search_inline->(insert: -op='eq');
			$search_inline->(insert: 'id_host'=$search_hostid);
		/if;
		if: $search_name != '';
			$search_inline->(insert: 'name'=$search_name);
		/if;
		if: $search_alias != '';
			$search_inline->(insert: 'name'=$search_alias);
		/if;
		if: $search_username != '';
			$search_inline->(insert: 'username'=$search_username);
		/if;
	/if;

	inline: -database='lasso_internal', -table='security_datasource_databases', $search_inline, -op='neq', 'id'=1;
		records;
			var: 'live' = (_database_names: (field: 'id_datasource'), (field: 'id_host'));
			var: 'temp' = (map);
			loop: (field_name: -count);
				$temp->(insert: (field_name: loop_count) = (field: (field_name: loop_count)));
			/loop;
			if: $live->(find: (field: 'name')) != (array);
				if: (field: 'enabled') == 'Y';
					$temp->(insert: 'status'='Enabled');
				else: (field: 'enabled') == 'N';
					$temp->(insert: 'status'='Disabled');
				else;
					$temp->(insert: 'status'='New');
				/if;
			else;
				$temp->(insert: 'status'='Not Available');
			/if;
			if: $temp->(find: 'alias') == '';
				$temp->(insert: 'alias'=(field: 'name'));
			/if;
			$search_databasemap->(insert: (field: 'id') = $temp);
		/records;
	/inline;

	if: ($search_action >> 'Search') && ($search_status != 'any');

		var: 'temp_array' = $search_databasemap;
		var: 'search_databasemap' = (array);

		iterate: $temp_array, (var: 'temp');
			var: 'id' = $temp->first;
			var: 'detail' = $temp->second;
			if: $detail->(find: 'status') == $search_status;
				$search_databasemap->(insert: $id = $detail);
			/if;
		/iterate;

	/if;

else: $datasource_action >> 'List Tables';

	// Redirect
	var: 'link' = $admin_link + '&tab3=tables' +
		'&datasource_connectorid=' + $datasource_connectorid +
		'&datasource_hostid=' + $datasource_hostid +
		'&datasource_databaseid=' + $datasource_databaseid;
	redirect_url: $link;
	output: '<a href="' + $link + '">' + $link + '</a>', -encodenone;
	abort;

/if;

//
// Process Navigation
//

if: $search_navigation >> 'Prev';
	$datasource_search_skip -= 10;
else: $search_navigation >> 'Next';
	$datasource_search_skip += 10;
else: $search_navigation >> 'First';
	$datasource_search_skip = 1;
else: $search_navigation >> 'Last';
	$datasource_search_skip = $search_databasemap->size - (($search_databasemap->size - 1) % 10);
else: $search_navigation >> 'Jump';
	$datasource_search_skip = integer: $search_jump;
/if;

var: 'found_count' = $search_databasemap->size;
var: 'datasource_search_skip' = integer: (math_max: 1, (math_min: $datasource_search_skip, $found_count));
var: 'shown_first' = $datasource_search_skip;
var: 'shown_last' = integer: (math_min: $found_count, $datasource_search_skip + 9);
var: 'shown_count' = ($shown_last - $shown_first + 1);

?>
