<pre>
<?LassoScript
	encode_set: -encodenone;

	'#[version: 7.0]\r\n';
	'#Lasso Security Settings\r\n';
	'#Copyright 2003-' + date->year + ' OmniPilot Software, Inc.\r\n';
	'#<a href="http://www.blueworld.com/">http://www.blueworld.com/</a>\r\n';
	'#\r\n';
	'#\r\n';
	'#    Use the browser\'s "Save" command to save this text into a file.\r\n';
	'#\r\n';
	'#    The security settings can later be imported into Lasso Administration using\r\n';
	'#    the "Import..." command in the Setup > Global > Import/Export section.\r\n';
	'#\r\n';
	'#    Do not edit this file directly.  No user-servicable parts inside.\r\n';
	'#\r\n';
	'#\r\n';

	var: 'schema' = (array);
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='global_prefs'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='jdbc_drivers'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_datasources'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_datasource_hosts'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_datasource_databases'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_database_tables'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_table_fields'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_users', 'query'=(array: -op='gt', 'id'='2')));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_ug_map'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_tags', 'query'=(array: -op='neq', 'enabled'='Y')));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_groups', 'query'=(array: -op='gt', 'id'='2')));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_group_host_map'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_group_db_map'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_group_table_map'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_group_file_perms'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_group_generic_perms'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_group_tag_map', 'query'=(array: -op='neq', 'allow_exec'='Y', -op='neq', 'id_group'='1')));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='sites'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='site_prefs'));
	$schema->(insert: (map: 'database'='site', 'table'='_OutgoingEmailPrefs'));
	$schema->(insert: (map: 'database'='site', 'table'='_Schedule'));
	$schema->(insert: (map: 'database'='site', 'table'='_Maintenance'));
	$schema->(insert: (map: 'database'='lasso_admin', 'table'='admin_prefs'));
	
	iterate: $schema, (var: 'temp_schema');
		var: 'inline' = (array:
				-database=$temp_schema->(find: 'database'),
				-table=$temp_schema->(find: 'table'),
				-maxrecords='all'		
		);
		
		if: ($temp_schema->(find: 'query') != null);
			$inline->(merge: $temp_schema->(find: 'query'));
			$inline->(insert: -search='action');
		else;
			$inline->(insert: -findall='action');
		/if;
		
		inline: $inline;
			
			var: 'names' = array;
			if: ($temp_schema->(find: 'fields')->type == 'array');
				iterate: $temp_schema->(find: 'fields'), (var: 'temp_field');
					$names->(insert: $temp_field);
				/iterate;
			else;
				loop: (field_name: -count);
					$names->(insert: (field_name: loop_count));
				/loop;
			/if;		
			'[' + (database_name) + '.' + (table_name) + ': ' + $names->(join:', ') + ']\r\n';
			
			if: (found_count > 0);
				var: 'records' = array;
				records;
					var: 'fields' = array;
					iterate: $names, (var: 'temp');
						$fields->(insert: (encode_sql: (field: $temp)));
					/iterate;
					$records->(insert: '("' + $fields->(join:'","') + '")');
				/records;
				'  ' + $records->(join:',\r\n  ') + '\r\n';
			/if;
			
			'[/' + (table_name) + ']\r\n';
		/inline;
	/iterate;
	
	'#END\r\n';
	'\r\n';

	/encode_set;
?>
</pre>