<?LassoScript

	_admin_addvar: -name="action", -override=(action_param: 'action'), -default='none';

	var: 'schema' = (array);
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='global_prefs'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='jdbc_drivers'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_datasources'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_datasource_hosts'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_datasource_databases'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_database_tables'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_table_fields'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_users', 'delete'='id > "2"'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_ug_map'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_tags'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_groups', 'delete'='id > "2"'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_group_host_map'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_group_db_map'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_group_table_map'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_group_file_perms'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_group_generic_perms'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='security_group_tag_map'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='sites'));
	$schema->(insert: (map: 'database'='lasso_internal', 'table'='site_prefs'));
	$schema->(insert: (map: 'database'='site', 'table'='_OutgoingEmailPrefs'));
	$schema->(insert: (map: 'database'='site', 'table'='_Schedule'));
	$schema->(insert: (map: 'database'='site', 'table'='_Maintenance'));
	$schema->(insert: (map: 'database'='lasso_admin', 'table'='admin_prefs'));

	if: ($action >> 'Import');

		var: 'import_files' = (file_uploads);
		
		var: 'import_error' = '';
		var: 'import_success' = '';
		var: 'import_cancel' = false;
		
		if: !($import_files->size > 0);
			var: 'import_error' = 'Select the file which contains the data browser solution to import.';
			var: 'import_cancel' = true;	
		/if;
		
		if: ($import_error == '');
			var: 'import_data' = (file_read: $import_files->(get: 1)->(find: 'upload.name'));
		/if;
		
		if: ($import_cancel == false);
		
			var: 'import_version' = (string_findregexp: $import_data, -find='\\[version: ?[^\\]]*\\]');
			if: ($import_version->size < 1) || !($import_version->(get: 1) >> '7.0');
				var: 'import_error' = 'The import file is in an unknown format.';
				var: 'import_cancel' = true;	
		/if;
			
		/if;
			
		if: ($import_cancel == false);
					
			iterate: $schema, (var: 'temp_schema');
				
				if: ($import_error == '');
				
					var: 'import_array' = (string_findregexp: $import_data, -find='\\[' + $temp_schema->(find: 'database') + '\\.' + $temp_schema->(find: 'table') + ': ?([^\\]]*)\\]([^\\[]*)\\[/' + $temp_schema->(find: 'table') + '\\]');
		
					if: ($import_array->size > 2);				
						var: 'import_fields' = $import_array->(get:2);	
						var: 'import_temp' = $import_array->(get:3);
						$import_temp->trim;
						
						var: 'delete_sql' = 'DELETE FROM `' + $temp_schema->(find: 'table') + '`';
						if: $temp_schema->(find: 'delete') != null;
							$delete_sql += ' WHERE ' + $temp_schema->(find: 'delete');
						/if;
						$temp_schema->(insert: 'delete_sql' = $delete_sql);

						if: ($import_temp != '') && ($import_temp !>> ';');		
							var: 'insert_sql' = 'INSERT INTO `' + $temp_schema->(find: 'table') + '` (' + $import_fields + ') VALUES ' + $import_temp;					
							$temp_schema->(insert: 'insert_sql' = $insert_sql);
						/if;						
					/if;
					
					if: ((string: $temp_schema->(find: 'insert_sql')) >> ';');
						var: 'import_error' = 'The import file has been corrupted.';
						var: 'import_cancel' = true;	
					/if;
				
				/if;
				
			/iterate;

		/if;
		
		if: ($import_cancel == false);

			iterate: $schema, (var: 'temp_schema');
						
				var: 'delete_sql' = $temp_schema->(find: 'delete_sql');
				var: 'insert_sql' = $temp_schema->(find: 'insert_sql');
			
				if: ($delete_sql != '');
										
					error_seterrormessage: (error_noerror);
					error_seterrorcode: (error_noerror: -errrorcode);
										
					inline: -database=$temp_schema->(find: 'database'),
							-sql=$delete_sql,
							-maxrecords='all';
					
						if: (error_currenterror) != (error_noerror);
							$import_error += (error_currenterror) + '<br>';
						/if;
																				
					/inline;
				/if;
														
				if: ($insert_sql != '');

					error_seterrormessage: (error_noerror);
					error_seterrorcode: (error_noerror: -errrorcode);

					inline: -database=$temp_schema->(find: 'database'),
							-sql=$insert_sql,
							-maxrecords='all';
					
						if: (error_currenterror) != (error_noerror);
							$import_error += (error_currenterror) + '<br>';
						/if;
																				
					/inline;
					
				/if;
												
			/iterate;
			
		/if;
		
		if: ($import_error == '');
	
			var: 'import_success' = 'The import completed successfully.';

		/if;
		
 		_security_flushcaches;
							
	/if;

?>
