<?LassoScript

// -----------
// global vars

var:'kDefaultExt' = '.lasso .lassoapp .txt .text .htm .html .inc .uld';
var:'kReservedExt' = (array:'.lasso','.lassoapp','.uld');

$kDefaultExt->freezevalue;
$kReservedExt->freezevalue;

var:'err'= 0, 'err_msg'='';
var:'db' = 'lasso_internal';

var:'settings_map'=map;
var:'file_array' = array;
var:'file_list' = '';
var:'settings_action' = (action_param:'action');


// -----------
// main

if: action_param:'dialog_action' != null;
	$settings_action = action_param:'dialog_action';
/if;

if: (action_param:'current_ext') >> ' ';
	$file_array = (action_param:'current_ext')->split:' ';
else: (action_param:'current_ext') != null;
	$file_array = (array: action_param:'current_ext');
/if;

// get the data
inline: -database=(_admin_internaldatabase), -sql='SELECT store_key, data, date_format(modified, \'%m/%d/%Y %T\') AS modified FROM lasso_internal.global_prefs
WHERE store_key IN (\'lasso_classic_enabled\',\'lasso_file_extensions\',\'lasso_strict_syntax\')';
	$err = error_currenterror:-errorcode; $err_msg = error_currenterror;
	if: !$err && found_count;
		records;
			$settings_map->(insert:(field:'store_key')=(field:'data'));
		/records;
	/if;
/inline;

// set up default values
if: $settings_map->(find:'lasso_file_extensions') != null;
	$settings_map->(find:'lasso_file_extensions')->(trim:' ');
/if;

if: !($settings_map->(find:'lasso_file_extensions') >> '.');

	if: $settings_map->(find:'lasso_file_extensions')->type == 'null';
		inline: -add, -database=$db, -table='global_prefs',
				'store_key'='lasso_file_extensions', 'data' = ' ' + $kDefaultExt + ' ';
		/inline;
	else;
		inline: -update, -database=$db, -table='global_prefs',
				-keyfield='store_key', -keyvalue='lasso_file_extensions',
				'data' = ' ' + $kDefaultExt + ' ';
		/inline;
	/if;

	$settings_map->insert:'lasso_file_extensions' = $kDefaultExt;
/if;

$file_array = $settings_map->(find:'lasso_file_extensions')->split:' ';

if: $settings_map->(find:'lasso_classic_enabled')->type == 'null';
	inline: -add, -database=$db, -table='global_prefs',
			'store_key'='lasso_classic_enabled', 'data' = 'Y'; // enabled
	/inline;
	$settings_map->insert:'lasso_classic_enabled' = 'Y';
/if;

// Check whether strict syntax is on or off
if: (_strict_literals);
	var: 'strict_syntax' = 'Y';
else;
	var: 'strict_syntax' = 'N';
/if;

// Store current setting in the database
if: ($settings_map->(find:'lasso_strict_syntax')->type == 'null') || ($settings_map->(find:'lasso_strict_syntax') != $strict_syntax);
	inline: -add, -database=$db, -table='global_prefs',
			'store_key'='lasso_strict_syntax', 'data' = $strict_syntax;
	/inline;
	$settings_map->insert:'lasso_strict_syntax' = $strict_syntax;
/if;


// dispatch
if: $settings_action >> 'Update';

	inline: -update, -database=$db, -table='global_prefs',
			-keyfield='store_key', -keyvalue='lasso_classic_enabled',
			'data' = (action_param:'lasso_classic');
		$err = error_currenterror:-errorcode; $err_msg = error_currenterror;
	/inline;
	$settings_map->insert:'lasso_classic_enabled' = (action_param:'lasso_classic');

	inline: -update, -database=$db, -table='global_prefs',
			-keyfield='store_key', -keyvalue='lasso_strict_syntax',
			'data' = (action_param:'lasso_strict_syntax');
		$err = error_currenterror:-errorcode; $err_msg = error_currenterror;
	/inline;
	$settings_map->insert:'lasso_strict_syntax' = (action_param:'lasso_strict_syntax');

	_strict_literals: ((action_param:'lasso_strict_syntax') == 'Y');
	_security_flushcaches;

else: $settings_action >> 'Remove';

	loop:(action_param:'file_ext',-count);
		if: !($kReservedExt->find:(action_param:'file_ext',loop_count))->size;
			$file_array->removeall:(action_param:'file_ext',loop_count);
		/if;
	/loop;

	inline: -update, -database=$db, -table='global_prefs', -keyfield='store_key', -keyvalue='lasso_file_extensions',
			'data'=' ' + (list_tostring:'file_array', -listdelimiter=' ') + ' ';

		$err = error_currenterror:-errorcode; $err_msg = error_currenterror;
	/inline;

	_security_flushcaches;

else: $settings_action >> 'Add';

	if: (action_param:'file_ext_new') != '' && !($file_array->find:action_param:'file_ext_new')->size;
		$file_array->insert:(action_param:'file_ext_new');

		inline: -update, -database=$db, -table='global_prefs',
				-keyfield='store_key', -keyvalue='lasso_file_extensions',
				'data' = ' ' + (list_tostring:'file_array', -listdelimiter=' ') + ' ';
			$err = error_currenterror:-errorcode; $err_msg = error_currenterror;
		/inline;
	/if;

	_security_flushcaches;
/if;

?>
