<?LassoScript

//
// Variables
//

_admin_addvar: 'groups_action', -default='None', -override=(action_param: 'groups_action', (action_param: 'groups_action', -count));
_admin_addvar: 'groups_database_skip', -default=1, -session='_admin', -override=(action_param: 'groups_database_skip');
_admin_addvar: 'groups_navigation', -override=(action_param: 'groups_navigation');
_admin_addvar: 'groups_jump', -override=(action_param: 'groups_jump');

_admin_addvar: 'groups_actionid', -default=$groups_databaseid, -override=(action_param: 'groups_actionid');

_admin_addvar: 'database_show', -override=(action_param: 'database_show');
_admin_addvar: 'database_search', -override=(action_param: 'database_search');
_admin_addvar: 'database_add', -override=(action_param: 'database_add');
_admin_addvar: 'database_update', -override=(action_param: 'database_update');
_admin_addvar: 'database_delete', -override=(action_param: 'database_delete');
_admin_addvar: 'database_sql', -override=(action_param: 'database_sql');
_admin_addvar: 'database_scripts', -override=(action_param: 'database_scripts');

_admin_addvar: 'dialog_action', -default='None', -override=(action_param: 'dialog_action');


//
// Process Action
//

if: ($dialog_action >> 'Unassign All');

	var: 'sql' = 'DELETE FROM security_group_db_map WHERE id_group = ' + $groups_groupid;
	inline: -database=(_admin_internaldatabase), -sql=$sql;
	/inline;

	_security_flushcaches;

	var: 'groups_action' = 'Detail';

else: ($groups_action >> 'Unassign');

	var: 'sql' = 'DELETE FROM security_group_db_map WHERE id_group = ' + $groups_groupid + ' AND id_database = ' + $groups_actionid;
	inline: -database=(_admin_internaldatabase), -sql=$sql;
	/inline;

	_security_flushcaches;

	var: 'groups_action' = 'Detail';

else: ($groups_action >> 'Assign');

	var: 'allow'=(array);
	var: 'deny'=(array);

	if: $database_show >> 'Allow'; $allow->(insert: 'I'); /if;
	if: $database_search >> 'Allow'; $allow->(insert: 'S'); /if;
	if: $database_add >> 'Allow'; $allow->(insert: 'A'); /if;
	if: $database_update >> 'Allow'; $allow->(insert: 'U'); /if;
	if: $database_delete >> 'Allow'; $allow->(insert: 'D'); /if;
	if: $database_sql >> 'Allow'; $allow->(insert: 'Q'); /if;
	if: $database_scripts >> 'Allow'; $allow->(insert: 'X'); /if;
	if: $database_show >> 'Deny'; $deny->(insert: 'I'); /if;
	if: $database_search >> 'Deny'; $deny->(insert: 'S'); /if;
	if: $database_add >> 'Deny'; $deny->(insert: 'A'); /if;
	if: $database_update >> 'Deny'; $deny->(insert: 'U'); /if;
	if: $database_delete >> 'Deny'; $deny->(insert: 'D'); /if;
	if: $database_sql >> 'Deny'; $deny->(insert: 'Q'); /if;
	if: $database_scripts >> 'Deny'; $deny->(insert: 'X'); /if;

	var: 'sql' = 'DELETE FROM security_group_db_map WHERE id_group = ' + $groups_groupid + ' AND id_database = ' + $groups_actionid;
	inline: -database=(_admin_internaldatabase), -sql=$sql;
	/inline;

	inline: -add,
		-database=(_admin_internaldatabase),
		-table='security_group_db_map',
		'id_group' = $groups_groupid,
		'id_database' = $groups_actionid,
		'allow'=$allow->(join: ','),
		'deny'=$deny->(join: ',');
	/inline;

	_security_flushcaches;

	var: 'groups_action' = 'Detail';

else: $groups_action >> 'Allow All';

	var: 'sql' = 'DELETE FROM security_group_db_map WHERE id_group = ' + $groups_groupid + ' AND id_database = ' + $groups_actionid;
	inline: -database=(_admin_internaldatabase), -sql=$sql;
	/inline;

	inline: -add,
		-database=(_admin_internaldatabase),
		-table='security_group_db_map',
		'id_group' = $groups_groupid,
		'id_database' = $groups_actionid,
		'allow'='I,S,A,U,D,Q,X',
		'deny'='';
	/inline;

	_security_flushcaches;

	var: 'groups_action' = 'Detail';

else: $groups_action >> 'Deny All';

	var: 'sql' = 'DELETE FROM security_group_db_map WHERE id_group = ' + $groups_groupid + ' AND id_database = ' + $groups_actionid;
	inline: -database=(_admin_internaldatabase), -sql=$sql;
	/inline;

	inline: -add,
		-database=(_admin_internaldatabase),
		-table='security_group_db_map',
		'id_group' = $groups_groupid,
		'id_database' = $groups_actionid,
		'allow'='',
		'deny'='I,S,A,U,D,Q,X';
	/inline;

	_security_flushcaches;

	var: 'groups_action' = 'Detail';

else: $groups_action >> 'List Tables';

	// Redirect
	var: 'link' = $admin_link + '&tab3=tables' +
		'&groups_connectorid=' + $groups_connectorid +
		'&groups_hostid=' + $groups_hostid +
		'&groups_databaseid=' + $groups_databaseid +
		'&groups_tableid=' + $groups_tableid;
	redirect_url: $link;
	output: '<a href="' + $link + '">' + $link + '</a>', -encodenone;
	abort;

else: $groups_action >> 'All Tables';

	// Redirect
	var: 'link' = $admin_link + '&tab3=tables' +
		'&groups_connectorid=' + $groups_connectorid +
		'&groups_hostid=' + $groups_hostid +
		'&groups_databaseid=' + $groups_databaseid +
		'&groups_tableid=' + $groups_tableid +
		'&groups_action=all+tables';
	redirect_url: $link;
	output: '<a href="' + $link + '">' + $link + '</a>', -encodenone;
	abort;

/if;


//
// Add Permissions to groups_databasemap for current group
//
if: ($groups_groupdetail != null);
	var: 'db_ids' = (array);
	iterate: $groups_databasemap, (var: 'item');
		$db_ids->(insert: $item->first);
	/iterate;

	var: 'sql' = 'SELECT * FROM security_group_db_map ' +
		'WHERE id_group = ' + $groups_groupdetail->(find: 'id') + ' AND id_database IN (' + $db_ids->(join: ',') + ')';

	inline: -database=(_admin_internaldatabase), -sql=$sql, -maxrecords='all';
		records;
			var: 'index' = $groups_databasemap->(findindex: (field: 'id_database'))->(get:1);
			var: 'temp' = $groups_databasemap->(get: $index)->second;
			if: ($temp != null);
				$temp->(insert: 'allow'=(field: 'allow'));
				$temp->(insert: 'deny'=(field: 'deny'));
				$groups_databasemap->(get: $index)->second = $temp;
			/if;
		/records;
	/inline;

/if;


if: ($groups_action >> 'All Databases') || ($groups_actionid == 1);

	var: 'sql' = 'SELECT * FROM security_group_db_map ' +
		'WHERE id_group = ' + $groups_groupdetail->(find: 'id') + ' AND id_database=1';

	var: 'temp' = (map);
	$temp->(insert: 'id'=1);
	$temp->(insert: 'name'='All Databases');

	inline: -database=(_admin_internaldatabase), -sql=$sql, -maxrecords='all';
		$temp->(insert: 'allow'=(field: 'allow'));
		$temp->(insert: 'deny'=(field: 'deny'));
	/inline;

	var: 'groups_databaseid' = 1;
	var: 'groups_databasedetail' = $temp;
	var: 'groups_action' = 'Detail';

else;

	var: 'temp' = (_admin_defaultdatabase: $groups_databaseid, $groups_databasemap);
	if: ($temp != null);
		var: 'groups_databaseid' = $temp->first;
		var: 'groups_databasedetail' = $temp->second;
		var: 'groups_databasename' = $groups_databasedetail->(find: 'name');
		var: 'groups_databasealias' = $groups_databasedetail->(find: 'alias');
	else;
		var: 'groups_databaseid' = 0;
	/if;

/if;


//
// Process Navigation
//

if: $groups_navigation >> 'Prev';
	$groups_database_skip -= 10;
else: $groups_navigation >> 'Next';
	$groups_database_skip += 10;
else: $groups_navigation >> 'First';
	$groups_database_skip = 1;
else: $groups_navigation >> 'Last';
	$groups_database_skip = $groups_databasemap->size - (($groups_databasemap->size - 1) % 10);
else: $groups_navigation >> 'Jump';
	$groups_database_skip = integer: $groups_jump;
/if;

var: 'found_count' = $groups_databasemap->size;
var: 'groups_database_skip' = integer: (math_max: 1, (math_min: $groups_database_skip, $found_count));
var: 'shown_first' = $groups_database_skip;
var: 'shown_last' = integer: (math_min: $found_count, $groups_database_skip + 9);
var: 'shown_count' = ($shown_last - $shown_first + 1);

?>
