<?LassoScript
// This file sets up the environment in which the page will run.

// $admin_tab1 first-tier tab selection
// $admin_tab2 second-tier tab selection
// $admin_tab3 third-tier tab selection


// -----------
// global vars

var:'err'= 0, 'err_msg'='';
var:'db' = 'lasso_internal';
var:'groups_skiprecords' = 0;
var:'groups_maxrecords' = 10;
var:'groups_action' = '';
var:'group_ids' = '';
var:'groups_keyset' = action_param:'groups_keyset';
var:'search_name' = action_param:'search_name';
var:'search_created' = action_param:'search_created';
var:'search_modified' = action_param:'search_modified';

var:'search_params' = (array:'-op'='neq','id'=2);	// admin group

var:'link_group' = (var: 'admin_file') + '?tab1=' + $admin_tab1 + '&tab2=' + $admin_tab2 + '&tab3=groups&dummy=' +
	 (date_difference: date_getcurrentdate, '7/1/2001', -secondsbetween);
var:'link_users' = (var: 'admin_file') + '?tab1=' + $admin_tab1 + '&tab2=users&tab3=users&dummy=' +
	 (date_difference: date_getcurrentdate, '7/1/2001', -secondsbetween);


// -----------
// main

if: action_param:'dialog_action' != null;
	$groups_action = action_param:'dialog_action';
else: action_param:'action' != null;
	$groups_action = action_param:'action';
/if;

if: action_param:'skip' != null;
	$groups_skiprecords = string_tointeger:(action_param:'skip');
/if;
if: action_param:'maxr' != null;
	$groups_maxrecords = string_tointeger:(action_param:'max');
/if;


if: $groups_action >> 'Clear';

	redirect_url: $admin_file + '?tab1=' + $admin_tab1 + '&tab2=' + $admin_tab2 + '&tab3=' + $admin_tab3 +
				  '&dummy=' + (date_difference: date_getcurrentdate, '7/1/2001', -secondsbetween);

/if;

if: $groups_action >> 'Search';
	if: action_param:'search_name' != null;
		$search_params->insert:'name'=(action_param:'search_name');
	/if;
	if: action_param:'search_enabled' != null;
		$search_params->insert:'enabled'=(action_param:'search_enabled');
	/if;
	if: action_param:'search_created' != null;
		$search_params->insert:'-op'=(action_param:'search_created_op');
		$search_params->insert:'created'=(date_format:(action_param:'search_created'), -dateformat='%Y-%m-%d');
	/if;
	if: action_param:'search_modified' != null;
		$search_params->insert:'-op'=(action_param:'search_modified_op');
		$search_params->insert:'modified'=(date_format:(action_param:'search_modified'), -dateformat='%Y-%m-%d');
	/if;
/if;

if: $groups_action >> 'Next';
	$groups_skiprecords += $groups_maxrecords;
else: $groups_action >> 'Prev';
	$groups_skiprecords = (math_max: $groups_skiprecords - $groups_maxrecords, 0);
/if;

if: $groups_keyset;
	if: $groups_action >> 'Enable All';
		// enable all shown groups
		inline: -database=$db,
				-sql='update lasso_internal.security_groups set enabled = \'Y\' where id in (' + $groups_keyset + ')';
		/inline;

		_admin_refreshsecurity;
		_security_flushcaches;

	else: $groups_action >> 'Disable All';
		// disable all shown groups
		inline: -database=$db,
				-sql='update lasso_internal.security_groups set enabled = \'N\' where id in (' + $groups_keyset + ') and id > 2';
		/inline;

		_admin_refreshsecurity;
		_security_flushcaches;
	/if;
/if;

//find
if: $groups_action;
	inline: -search, -inlinename='groups', -database=$db, -table='security_groups',
			-skiprecords=$groups_skiprecords, -maxrecords=$groups_maxrecords, $search_params;
		$err = error_currenterror:-errorcode; $err_msg = error_currenterror;
		var:'found_count'=found_count, 'shown_first'=shown_first, 'shown_last'=shown_last;

		records;
			$group_ids += (field:'id') + ',';
		/records;
		$group_ids->removetrailing:',';
	/inline;
/if;
?>
