<?LassoScript

//
// Variables
//

_admin_addvar: 'groups_action', -default='None', -override=(action_param: 'groups_action', (action_param: 'groups_action', -count));
_admin_addvar: 'groups_table_skip', -default=1, -session='_admin', -override=(action_param: 'groups_table_skip');
_admin_addvar: 'groups_navigation', -override=(action_param: 'groups_navigation');
_admin_addvar: 'groups_jump', -override=(action_param: 'groups_jump');

_admin_addvar: 'groups_actionid', -default=$groups_tableid, -override=(action_param: 'groups_actionid');

_admin_addvar: 'table_show', -override=(action_param: 'table_show');
_admin_addvar: 'table_search', -override=(action_param: 'table_search');
_admin_addvar: 'table_add', -override=(action_param: 'table_add');
_admin_addvar: 'table_update', -override=(action_param: 'table_update');
_admin_addvar: 'table_delete', -override=(action_param: 'table_delete');

_admin_addvar: 'dialog_action', -default='None', -override=(action_param: 'dialog_action');


//
// Process Action
//

if: ($dialog_action >> 'Unassign All');

	var: 'sql' = 'DELETE FROM security_group_table_map WHERE id_group = ' + $groups_groupid;
	inline: -database=(_admin_internaldatabase), -sql=$sql;
	/inline;

	_security_flushcaches;

	var: 'groups_action' = 'Detail';

else: ($groups_action >> 'Unassign');

	var: 'sql' = 'DELETE FROM security_group_table_map WHERE id_group = ' + $groups_groupid + ' AND id_table = ' + $groups_actionid;
	inline: -database=(_admin_internaldatabase), -sql=$sql;
	/inline;

	_security_flushcaches;

	var: 'groups_action' = 'Detail';

else: ($groups_action >> 'Assign');

	var: 'allow'=(array);
	var: 'deny'=(array);

	if: $table_show >> 'Allow'; $allow->(insert: 'I'); /if;
	if: $table_search >> 'Allow'; $allow->(insert: 'S'); /if;
	if: $table_add >> 'Allow'; $allow->(insert: 'A'); /if;
	if: $table_update >> 'Allow'; $allow->(insert: 'U'); /if;
	if: $table_delete >> 'Allow'; $allow->(insert: 'D'); /if;
	if: $table_show >> 'Deny'; $deny->(insert: 'I'); /if;
	if: $table_search >> 'Deny'; $deny->(insert: 'S'); /if;
	if: $table_add >> 'Deny'; $deny->(insert: 'A'); /if;
	if: $table_update >> 'Deny'; $deny->(insert: 'U'); /if;
	if: $table_delete >> 'Deny'; $deny->(insert: 'D'); /if;

	var: 'sql' = 'DELETE FROM security_group_table_map WHERE id_group = ' + $groups_groupid + ' AND id_table = ' + $groups_actionid;
	inline: -database=(_admin_internaldatabase), -sql=$sql;
	/inline;

	inline: -add,
		-database=(_admin_internaldatabase),
		-table='security_group_table_map',
		'id_group' = $groups_groupid,
		'id_table' = $groups_actionid,
		'allow'=$allow->(join: ','),
		'deny'=$deny->(join: ',');
	/inline;

	_security_flushcaches;

	var: 'groups_action' = 'Detail';

else: $groups_action >> 'Allow All';

	var: 'sql' = 'DELETE FROM security_group_table_map WHERE id_group = ' + $groups_groupid + ' AND id_table = ' + $groups_actionid;
	inline: -database=(_admin_internaldatabase), -sql=$sql;
	/inline;

	inline: -add,
		-database=(_admin_internaldatabase),
		-table='security_group_table_map',
		'id_group' = $groups_groupid,
		'id_table' = $groups_actionid,
		'allow'='I,S,A,U,D',
		'deny'='';
	/inline;

	_security_flushcaches;

	var: 'groups_action' = 'Detail';

else: $groups_action >> 'Deny All';

	var: 'sql' = 'DELETE FROM security_group_table_map WHERE id_group = ' + $groups_groupid + ' AND id_table = ' + $groups_actionid;
	inline: -database=(_admin_internaldatabase), -sql=$sql;
	/inline;

	inline: -add,
		-database=(_admin_internaldatabase),
		-table='security_group_table_map',
		'id_group' = $groups_groupid,
		'id_table' = $groups_actionid,
		'allow'='',
		'deny'='I,S,A,U,D';
	/inline;

	_security_flushcaches;

	var: 'groups_action' = 'Detail';

else: $groups_action >> 'All Databases';

	// Redirect
	var: 'link' = $admin_link + '&tab3=databases' +
		'&groups_connectorid=' + $groups_connectorid +
		'&groups_hostid=' + $groups_hostid +
		'&groups_databaseid=' + $groups_databaseid +
		'&groups_action=all+databases';
	redirect_url: $link;
	output: '<a href="' + $link + '">' + $link + '</a>', -encodenone;
	abort;

/if;


//
// Add Permissions to groups_databasemap for current group
//
if: ($groups_groupdetail != null);
	var: 'db_ids' = (array);
	iterate: $groups_tablemap, (var: 'item');
		$db_ids->(insert: $item->first);
	/iterate;

	var: 'sql' = 'SELECT * FROM security_group_table_map ' +
		'WHERE id_group = ' + $groups_groupdetail->(find: 'id') + ' AND id_table IN (' + $db_ids->(join: ',') + ')';

	inline: -database=(_admin_internaldatabase), -sql=$sql, -maxrecords='all';
		records;
			var: 'index' = $groups_tablemap->(findindex: (field: 'id_table'))->(get:1);
			var: 'temp' = $groups_tablemap->(get: $index)->second;
			if: ($temp != null);
				$temp->(insert: 'allow'=(field: 'allow'));
				$temp->(insert: 'deny'=(field: 'deny'));
				$groups_tablemap->(get: $index)->second = $temp;
			/if;
		/records;
	/inline;

/if;

if: ($groups_action >> 'All Tables') || ($groups_actionid == 1);

	var: 'sql' = 'SELECT * FROM security_group_table_map ' +
		'WHERE id_group = ' + $groups_groupdetail->(find: 'id') + ' AND id_table=1';

	var: 'temp' = (map);
	$temp->(insert: 'id'=1);
	$temp->(insert: 'name'='All Tables');

	inline: -database=(_admin_internaldatabase), -sql=$sql, -maxrecords='all';
		$temp->(insert: 'allow'=(field: 'allow'));
		$temp->(insert: 'deny'=(field: 'deny'));
	/inline;

	var: 'groups_tableid' = 1;
	var: 'groups_tabledetail' = $temp;
	var: 'groups_action' = 'Detail';

else;

	var: 'temp' = (_admin_defaulttable: $groups_tableid, $groups_tablemap);
	if: ($temp != null);
		var: 'groups_tableid' = $temp->first;
		var: 'groups_tabledetail' = $temp->second;
		var: 'groups_tablename' = $groups_tabledetail->(find: 'name');
		var: 'groups_tablealias' = $groups_tabledetail->(find: 'alias');
	else;
		var: 'groups_tableid' = 0;
	/if;

/if;


//
// Process Navigation
//

if: $groups_navigation >> 'Prev';
	$groups_table_skip -= 10;
else: $groups_navigation >> 'Next';
	$groups_table_skip += 10;
else: $groups_navigation >> 'First';
	$groups_table_skip = 1;
else: $groups_navigation >> 'Last';
	$groups_table_skip = $groups_tablemap->size - (($groups_tablemap->size - 1) % 10);
else: $groups_navigation >> 'Jump';
	$groups_table_skip = integer: $groups_jump;
/if;

var: 'found_count' = $groups_tablemap->size;
var: 'groups_table_skip' = integer: (math_max: 1, (math_min: $groups_table_skip, $found_count));
var: 'shown_first' = $groups_table_skip;
var: 'shown_last' = integer: (math_min: $found_count, $groups_table_skip + 9);
var: 'shown_count' = ($shown_last - $shown_first + 1);

?>
