<?LassoScript

var: 'admin_refresh' = true;

_admin_addvar: 'dialog_action', -default='None', -override=(action_param: 'dialog_action');

_admin_addvar: 'email_status', -session='_admin', -default='queued', -override=(action_param: 'email_status');
_admin_addvar: 'email_action', -default='None', -override=(action_param: 'email_action');
_admin_addvar: 'email_search', -default='', -override=(action_param: 'email_search');
_admin_addvar: 'email_date', -default='', -override=(action_param: 'email_date');

_admin_addvar: 'email_query', -session='_admin', -default=null;

_admin_addvar: 'email_id', -default='', -override=(action_param: 'email_id');

_admin_addvar: 'email_skip', -default=0, -session='_admin', -override=(action_param: 'email_skip');
_admin_addvar: 'email_max', -default=10;
_admin_addvar: 'email_navigation', -override=(action_param: 'email_navigation');
_admin_addvar: 'email_jump', -override=(action_param: 'email_jump');
_admin_addvar: 'email_found', -override=(action_param: 'email_found');

_admin_addvar: 'email_sortfield', -default='id', -session='_admin', -override=(action_param: 'email_sortfield');
_admin_addvar: 'email_sortorder', -default='descending', -session='_admin', -override=(action_param: 'email_sortorder');

_admin_addvar: 'email_oldstatus', -session='_admin', -override=(action_param: 'email_oldstatus');
if: ($email_oldstatus == '') || ($email_oldstatus != $email_status);
	var: 'email_skip' = 0;
/if;

var: 'email_skip' = (integer: $email_skip);
var: 'email_max' = (integer: $email_max);
var: 'email_found' = (integer: $email_found);

if: ($email_navigation >> 'Next');
	$email_skip = (integer: ($email_skip + $email_max));
else: ($email_navigation >> 'Prev');
	$email_skip = (integer: (math_max: $email_skip - $email_max, 0));
else: ($email_navigation >> 'Last');
	$email_skip = $email_found->size - (($email_found->size - 1) % $email_max);
else: ($email_navigation >> 'First') || ($email_navigation >> 'Sort');
	$email_skip = 0;
else: ($email_navigation >> 'Jump') || ((action_param: 'email_navigation_skip') != '');
	$email_skip = (math_max: (integer: (action_param: 'email_navigation_skip')) - 1, 0);
/if;

if: ($email_skip > 0) && ($email_found > 0);
	$email_skip = (math_max: (math_min: $email_found - 1, $email_skip), 0);
/if;


var: 'email_inline' = (array);

$email_inline->(insert: -database='site');
$email_inline->(insert: -table='_OutgoingEmail');

$email_inline->(insert: -maxrecords=10);
$email_inline->(insert: -skiprecords=$email_skip);

$email_inline->(insert: -sortfield=$email_sortfield);
$email_inline->(insert: -sortorder=$email_sortorder);

if: $email_search != '';

	$email_inline->(insert: -opbegin='or');
	$email_inline->(insert: -op='cn');
	$email_inline->(insert: 'subject'=$email_search);
	$email_inline->(insert: -op='cn');
	$email_inline->(insert: 'body'=$email_search);
	$email_inline->(insert: -op='cn');
	$email_inline->(insert: 'toemail'=$email_search);
	$email_inline->(insert: -op='cn');
	$email_inline->(insert: 'fromemail'=$email_search);
	$email_inline->(insert: -op='cn');
	$email_inline->(insert: 'cc'=$email_search);
	$email_inline->(insert: -op='cn');
	$email_inline->(insert: 'bcc'=$email_search);
	$email_inline->(insert: -opend='or');
/if;

if: $email_date != '';

	var: 'temp' = (string: (date_format: $email_date, -format='%Y%m%d%H%M%S'));
	if: $temp != '';
		$temp->(removetrailing: '00');
	else;
		$temp=$email_date;
	/if;

	if: ($email_status >> 'queued');
		$email_inline->(insert: -op='cn');
		$email_inline->(insert: 'date_time_sub'=$temp);
	else;
		$email_inline->(insert: -opbegin='or');
		$email_inline->(insert: -op='cn');
		$email_inline->(insert: 'date_time_sent'=$temp);
		$email_inline->(insert: -op='cn');
		$email_inline->(insert: 'date_time_sub'=$temp);
		$email_inline->(insert: -opend='or');
	/if;
/if;

if: ($email_status >> 'all');

	if: ($email_date != '') || ($email_search != '');
		$email_inline->(insert: -search='');
	else;
		$email_inline->(insert: -findall='');
	/if;

else: ($email_status >> 'queued');

	$email_inline->(insert: -search='');
	$email_inline->(insert: -op='eq');
	$email_inline->(insert: 'date_time_sent'='1000-01-01 00:00:00');
	$email_inline->(insert: -opbegin='not');
	$email_inline->(insert: -op='bw');
	$email_inline->(insert: 'SMTPErr'='Error');
	$email_inline->(insert: -opend='not');

else: $email_status >> 'sent';

	$email_inline->(insert: -search='');
	$email_inline->(insert: -op='bw');
	$email_inline->(insert: 'SMTPErr'='Sent');

else: $email_status >> 'error';

	$email_inline->(insert: -search='');
	$email_inline->(insert: -op='bw');
	$email_inline->(insert: 'SMTPErr'='Error');

else: $email_status >> 'query';

	$email_inline->(merge: $email_query);

/if;

if: $dialog_action >> 'Delete Shown';

	var: 'id' = (array);
	inline: $email_inline, -maxrecords='all';
		records;
			$id->(insert: (field: 'id'));
		/records;
	/inline;

	if: $id->size > 0;
		inline: -database='site', -sql='DELETE FROM _OutgoingEmail WHERE id IN (' + $id->(join: ',') + ')';
		/inline;
	/if;

else: $dialog_action >> 'Delete All';

	inline: -database='site', -sql='DELETE FROM _OutgoingEmail';
	/inline;

else: $email_action >> 'Stop';

	inline: -database='site', -table='_outgoingemailprefs',
		-keyfield='id', -keyvalue='1', 'Pause'='1',	-update;
		
		Global: '__SMTP_Preferences__' = (map);
		Loop: (Field_Name: -Count);
			(Global: '__SMTP_Preferences__')->(Insert: (Field_Name: Loop_Count)=(Field: (Field_Name: Loop_Count)));
		/Loop;
		
	/inline;
	

else: $email_action >> 'Resume';

	inline: -database='site', -table='_outgoingemailprefs',
	   -keyfield='id', -keyvalue='1', 'Pause'='0', -update;

		Global: '__SMTP_Preferences__' = (map);
		Loop: (Field_Name: -Count);
			(Global: '__SMTP_Preferences__')->(Insert: (Field_Name: Loop_Count)=(Field: (Field_Name: Loop_Count)));
		/Loop;

	/inline;

else: $dialog_action >> 'Delete';

	if:!var:'email_id';
		var: 'err' = 1; 
		var: 'err_msg' = 'Missing email id';
	else;
		inline: -database='site', -table='_OutgoingEmail',
			    -keyfield='id', -keyvalue=(var:'email_id'), -delete;
			var: 'err' = error_currenterror:-errorcode; 
			var: 'err_msg' = error_currenterror;
		/inline;
	/if;

else: $dialog_action >> 'Requeue';

	if:!var:'email_id';
		var: 'err' = 1; 
		var: 'err_msg' = 'Missing email id';
	else;
		inline: -database='site', -table='_OutgoingEmail',
			    -keyfield='id', -keyvalue=(var:'email_id'), -search;
			var: 'err' = error_currenterror:-errorcode; 
			var: 'err_msg' = error_currenterror;
		    Email_Send:
			-Host=(field: 'smtpserver'),
			-From=(field: 'fromemail'),
			-Subject=(field: 'subject'),
			-Body=(field: 'body'),
	    		-To=(field: 'toemail'),
	    		-CC=(field: 'cc'),
	    		-BCC=(field: 'bcc');
		/inline;
		inline: -database='site', -table='_OutgoingEmail',
			    -keyfield='id', -keyvalue=(var:'email_id'), -delete;
			var: 'err' = error_currenterror:-errorcode; 
			var: 'err_msg' = error_currenterror;
		/inline;
	/if;

/if;

// Mail Queue Paused?
inline: -database='site', -table='_outgoingemailprefs', -keyfield='id', 'id'='1', -search;
	var: 'email_pause'= (field:'pause');
/inline;

?>