<?LassoScript

// ---------
// global vars

_admin_addvar: 'event_type', -default='URL', -override=(action_param: 'event_type');
_admin_addvar: 'event_action', -default='none', -override=(action_param: 'event_action', (action_param: 'event_action', -count));

_admin_addvar: 'event_url', -default='', -override=(action_param: 'event_url');
_admin_addvar: 'event_startdate', -default='', -force=(action_param: 'event_startdate');
_admin_addvar: 'event_enddate', -default='', -force=(action_param: 'event_enddate');
_admin_addvar: 'event_restart', -default='Yes', -override=(action_param: 'event_restart');
_admin_addvar: 'event_delay', -default='60', -override=(action_param: 'event_delay');
_admin_addvar: 'event_username', -default='', -force=(action_param: 'event_username');
_admin_addvar: 'event_password', -default='', -force=(action_param: 'event_password');

_admin_addvar: 'event_admin', -default='', -override=(action_param: 'event_admin');
_admin_addvar: 'event_repeat', -default='Once', -override=(action_param: 'event_repeat');
_admin_addvar: 'event_day', -default=(string: date->dayofweek), -override=(action_param: 'event_day');
_admin_addvar: 'event_time', -default=(string: date->(format: '%H:%M:%S')), -override=(action_param: 'event_time');

if: $event_startdate == 'MM/DD/YYYY HH:MM:SS';
	var: 'event_startdate' = '';
/if;

if: $event_enddate == 'MM/DD/YYYY HH:MM:SS';
	var: 'event_enddate' = '';
/if;

if: $event_repeat >> 'Once';
	var: 'event_delay' = 0;
	var: 'event_realdate' = $event_startdate;
	var: 'event_realrepeat' = 'No';
else: $event_repeat >> 'Daily';
	var: 'event_delay' = 24 * 60;
	var: 'event_realdate' = (string: date->(format: '%m/%d/%Y')) + ' ' + $event_time;
	if: (date_difference: date, $event_realdate, -minutesbetween) > 0;
		var: 'event_realdate' = (string: (date_add: $event_realdate, -day=1));
	/if;
	var: 'event_realrepeat' = 'Yes';
else: $event_repeat >> 'Weekly';
	var: 'event_delay' = 7 * 24 * 60;
	var: 'day' = (integer: $event_day) - (integer: date->dayofweek);
	if: $day < 0; $day += 7; /if;
	var: 'event_realdate' = (date_format: (date_add: date, -day=$day), -format='%m/%d/%Y') + ' ' + $event_time;
	if: (date_difference: date, $event_realdate, -minutesbetween) > 0;
		var: 'event_realdate' = (string: (date_add: $event_realdate, -day=7));
	/if;
	var: 'event_realrepeat' = 'Yes';
else: $event_repeat >> 'Custom';
	var: 'event_realdate' = $event_startdate;
	var: 'event_realrepeat' = 'Yes';
/if;

// ---------
// main

if: ($event_action >> 'Admin');

	if: !(var_defined: 'mysql_scheduleaction');
		redirect_url: (var: 'admin_link') +
			'&tab3=event' +
			'&event_status=maintenance' +
			'&event_skip=1000000';
		abort;
	else;
		var: 'event_admin' = $mysql_scheduleaction;
		var: 'event_type' = 'Admin';
	/if;

	var: 'action_array' = $event_admin->(split: ':');
	var: 'tables' = $action_array->(get: 3)->(split: ',');
	if: $tables->size > 4;
		while: $tables->size > 4;
			$tables->(remove);
		/while;
		$tables->(insert: '...');
	/if;

	local: 'event_admindisplay' =  $action_array->(get:1) + ' database ' + $action_array->(get:2) + ' tables ' + $tables->(join: ', ');

else: ($event_action >> 'Schedule');

	if: $event_realdate == '';
		var: 'event_realdate' = (string: date);
	/if;

	if: $event_enddate == '';
		var: 'event_enddate' = '1/1/3001 00:00:00';
	/if;

	if: ($event_type >> 'URL');

		Event_Schedule:
			-URL=$event_url,
			-Start=$event_realdate,
			-End=$event_enddate,
			-Restart=($event_restart == 'Yes'),
			-Repeat=($event_realrepeat == 'Yes'),
			-Delay=$event_delay,
			-Username=$event_username,
			-Password=$event_password;

		var: 'event_status' = 'schedule';

	else: ($event_type >> 'Admin');

		_Maintenance_Schedule:
			-Event=$event_admin,
			-Start=$event_realdate,
			-End=$event_enddate,
			-Repeat=($event_realrepeat == 'Yes'),
			-Restart=($event_restart == 'Yes'),
			-Delay=$event_delay;

		var: 'event_status' = 'maintenance';

	/if;

	redirect_url: (var: 'admin_link') +
		'&tab3=event' +
		'&event_status=' + $event_status +
		'&event_skip=1000000';
	abort;

/if;

if: $event_startdate == '';
	var: 'event_startdate' = 'MM/DD/YYYY HH:MM:SS';
/if;
if: $event_enddate == '';
	var: 'event_enddate' = 'MM/DD/YYYY HH:MM:SS';
/if;

?>
