<?LassoScript

//
// Variables
//

_admin_addvar: 'build_connectorid', -default='1', -session='_browse', -override=(action_param: 'build_connectorid');
_admin_addvar: 'build_hostid', -session='_browse', -override=(action_param: 'build_hostid');
_admin_addvar: 'build_databaseid', -session='_browse', -override=(action_param: 'build_databaseid');
_admin_addvar: 'build_tableid', -session='_browse', -override=(action_param: 'build_tableid');
_admin_addvar: 'build_fieldid', -session='_browse', -override=(action_param: 'build_fieldid');
_admin_addvar: 'build_indexid', -session='_browse', -override=(action_param: 'build_indexid');

_admin_addvar: 'build_action', -default='None', -override=(action_param: 'build_action', (action_param: 'build_action', -count));
_admin_addvar: 'build_index_skip', -default=1, -session='_browse', -override=(action_param: 'build_index_skip');
_admin_addvar: 'build_navigation', -override=(action_param: 'build_navigation');
_admin_addvar: 'build_jump', -override=(action_param: 'build_jump');

_admin_addvar: 'database_name', -override=(action_param: 'database_name');
_admin_addvar: 'database_alias', -override=(action_param: 'database_alias');

_admin_addvar: 'table_name', -override=(action_param: 'table_name');
_admin_addvar: 'table_alias', -override=(action_param: 'table_alias');

_admin_addvar: 'create_action', -default='None', -override=(action_param: 'create_action');
_admin_addvar: 'dialog_action', -default='None', -override=(action_param: 'dialog_action');

//output: 'b ' + $build_action + ' c ' + $create_action + ' d ' + $dialog_action + ' <br>', -encodenone;

//
// Process Field Parameters
//


//
// Process Action
//

if: ($build_action >> 'Create') && !(var_defined: 'build_indexdetail');

	// Create template for new index

//	output: ' creating template ';

	var: 'build_indexdetail'=(array: 1=(map: 'key_name'='', 'type'='index', 'column_name'=''));
/if;

if: $dialog_action >> 'Delete';

//	output: ' deleting index ';

	// Generate SQL to delete index

	var:'sql' = 'ALTER TABLE `' + $database_name + '`.`' + $table_name + '` DROP INDEX';
	$sql += ' `' + $build_indexid + '` ';

//	output: '<br>[' + $sql + '] ', -encodenone;

	inline: -database=$database_alias, -sql=$sql;
		if: (error_currenterror) != (error_noerror);
			var: 'build_error' = (error_currenterror) + ' (' + (error_currenterror: -errorcode) + ')';
		else;
			var: 'build_message' = 'The index was deleted successfully.';
		/if;
	/inline;

	var: 'build_action'='None';

/if;

if: $create_action >> 'Create';

	var: 'build_navigation' = 'last';

	if: ((var: 'create_name') != '') && (string_replaceregexp: (var: 'index_name'), -find='\\w|\\$', -replace='') != '';
		var: 'build_error'='Index names should consist of only letters, numbers, and the underscore character.';
	/if;

	if: ((var: 'build_error') == '');

		// Generate SQL to create field

		if: (action_param: 'index_type') == 'index';
			var:'sql' = 'ALTER TABLE `' + $database_name + '`.`' + $table_name + '` ADD INDEX ';
		else: (action_param: 'index_type') == 'unique';
			var:'sql' = 'ALTER TABLE `' + $database_name + '`.`' + $table_name + '` ADD UNIQUE ';
		else: (action_param: 'index_type') == 'primary';
			var:'sql' = 'ALTER TABLE `' + $database_name + '`.`' + $table_name + '` ADD PRIMARY KEY ';
		else: (action_param: 'index_type') == 'fulltext';
			var:'sql' = 'ALTER TABLE `' + $database_name + '`.`' + $table_name + '` ADD FULLTEXT ';
		/if;

		if: (action_param: 'index_name') != '';
			$sql += (action_param: 'index_name') + ' ';
		/if;

		$sql += '(';
		loop: (action_param: 'index_field', -count);
			if: (action_param: 'index_field', loop_count) != '';
				$sql += (action_param: 'index_field', loop_count);
				if: (action_param: 'index_prefix', loop_count) != '';
					$sql += '(' + (action_param: 'index_prefix', loop_count) + ')';
				/if;
				$sql += ',';
			/if;
		/loop;
		$sql->(removetrailing: ',');
		$sql += ')';

//		output: '<br>[' + $sql + '] ', -encodenone;

		inline: -database=$database_alias, -sql=$sql;
			if: (error_currenterror) != (error_noerror);
				var: 'build_error' = (error_currenterror) + ' (' + (error_currenterror: -errorcode) + ')';
			else;
				var: 'build_message' = 'The index was created successfully.';
			/if;
		/inline;

	/if;

	if: ((var: 'build_error') == '');
		var: 'build_action'='None';
	/if;

else: $create_action >> 'Silent';

	var: 'build_indexdetail'=(array); // : 1=(map: 'key_name'='', 'type'='index', 'column_name'=''));

	loop: (action_param: 'index_field', -count);
		var: 'temp' = (map);
		$temp->(insert: 'key_name' = (action_param: 'index_name'));
		$temp->(insert: 'type' = (action_param: 'index_type'));
		if: (action_param: 'index_field', loop_count) != '';
			$temp->(insert: 'column_name' = (action_param: 'index_field', loop_count));
			if: (action_param: 'index_prefix', loop_count) != '';
				$temp->(insert: 'index_prefix' = (action_param: 'index_prefix', loop_count));
			/if;
			$build_indexdetail->(insert: loop_count = $temp);
		/if;
	/loop;

	if: $build_indexdetail == (array);
		var: 'temp' = (map);
		$temp->(insert: 'key_name' = (action_param: 'index_name'));
		$temp->(insert: 'type' = (action_param: 'index_type'));
		$temp->(insert: 'column_name' = '');
		$build_indexdetail->(insert: 1 = $temp);
	/if;

/if;


//
// Build Menus
//

var: 'build_connectormap' = (array);
var: 'build_hostmap' = (array);
var: 'build_databasemap' = (array);
var: 'build_tablemap' = (array);
var: 'build_fieldmap' = (array);

if: ($build_action >> 'Refresh');
	_admin_refreshsecurity;
/if;

var: 'temp_connectormap' = (_admin_listconnectors);
var: 'build_connectormap' = (array);
loop: $temp_connectormap->size;
	var: 'temp'=$temp_connectormap->(get:loop_count)->second;
	var: 'id'=$temp_connectormap->(get:loop_count)->first;
	if: ($temp->(find: 'name') >> 'MySQL') && ($temp->(find: 'status') == 'enabled');
		$build_connectormap->(insert: $id = $temp);
	/if;
/loop;
var: 'temp' = (_admin_defaultconnector: -id=$build_connectorid, $build_connectormap);
if: ($temp != null);
	var: 'build_connectorid' = $temp->first;
	var: 'build_connectordetail' = $temp->second;
	var: 'build_connectoralias' = $build_connectordetail->(find: 'alias');
else;
	var: 'build_connectorid' = 0;
	var: 'build_connectordetail' = null;
/if;

if: ($build_action >> 'Refresh') && ($build_connectorid != 0);
	_admin_refreshconnector: $build_connectorid;
/if;

if: ($build_connectorid > 0);
	var: 'build_hostmap' = (_admin_listhosts: $build_connectorid);
	loop: -loopfrom=$build_hostmap->size, -loopto=1, -loopincrement=(-1);
		if: $build_hostmap->(get: loop_count)->second->(find: 'status') != 'enabled';
			$build_hostmap->(remove: loop_count);
		/if;
	/loop;
	var: 'temp' = (_admin_defaulthost: $build_hostid, $build_hostmap);
	if: ($temp != null);
		var: 'build_hostid' = $temp->first;
		var: 'build_hostdetail' = $temp->second;
	else;
		var: 'build_hostid' = 0;
		var: 'build_hostdetail' = null;
	/if;
else;
	var: 'build_hostid' = 0;
	var: 'build_hostdetail' = null;
/if;

if: ($build_hostid > 0);
	var: 'build_databasemap' = (_admin_listdatabases: $build_hostid);
	loop: -loopfrom=$build_databasemap->size, -loopto=1, -loopincrement=(-1);
		if: $build_databasemap->(get: loop_count)->second->(find: 'status') != 'enabled';
			$build_databasemap->(remove: loop_count);
		/if;
	/loop;
	var: 'temp' = (_admin_defaultdatabase: $build_databaseid, $build_databasemap);
	if: ($temp != null);
		var: 'build_databaseid' = $temp->first;
		var: 'build_databasedetail' = $temp->second;
		var: 'build_databasename' = $build_databasedetail->(find: 'name');
		var: 'build_databasealias' = $build_databasedetail->(find: 'alias');
	else;
		var: 'build_databaseid' = 0;
		var: 'build_databasedetail' = null;
	/if;
else;
	var: 'build_databaseid' = 0;
	var: 'build_databasedetail' = null;
/if;

if: ($build_databaseid > 0);
	var: 'build_tablemap' = (_admin_listtables: $build_databaseid);
	loop: -loopfrom=$build_tablemap->size, -loopto=1, -loopincrement=(-1);
		if: $build_tablemap->(get: loop_count)->second->(find: 'status') != 'enabled';
			$build_tablemap->(remove: loop_count);
		/if;
	/loop;
	var: 'temp' = (_admin_defaulttable: $build_tableid, $build_tablemap);
	if: ($temp != null);
		var: 'build_tableid' = $temp->first;
		var: 'build_tabledetail' = $temp->second;
		var: 'build_tablename' = $build_tabledetail->(find: 'name');
		var: 'build_tablealias' = $build_tabledetail->(find: 'alias');
	else;
		var: 'build_tableid' = 0;
		var: 'build_tabledetail' = null;
	/if;
else;
	var: 'build_tableid' = 0;
	var: 'build_tabledetail' = null;
/if;

if: ($build_action >> 'Refresh') && ($build_databasedetail != null) && ($build_tabledetail != null);
	inline: -database=$build_databasealias, -sql='ANALYZE TABLE `' + $build_databasename + '`.`' + $build_tablename + '`';
	/inline;
/if;

if: ($build_tableid > 0) && ($build_tabledetail->(find: 'status') == 'enabled');
	var: 'build_fieldmap' = (_admin_listfields: $build_tableid);
	var: 'temp' = (_admin_defaultfield: $build_fieldid, $build_fieldmap);
	if: ($temp != null);
		var: 'build_fieldid' = $temp->first;
		var: 'build_fielddetail' = $temp->second;
		var: 'build_fieldname' = $build_fielddetail->(find: 'name');
		var: 'build_fieldalias' = $build_fielddetail->(find: 'alias');
	else;
		var: 'build_fieldid' = 0;
		var: 'build_fielddetail' = null;
	/if;
else;
	var: 'build_fieldid' = 0;
	var: 'build_fielddetail' = null;
/if;


//
// Correct name of 'site' database
//

if: ($build_connectorid == 1) && ($build_databasename == 'site');
	var: 'build_databasename' = 'lasso_site_1';
/if;


//
// Add Field Types
//

if: (var:'build_databasealias') && (var:'build_databasename') && (var:'build_tablename');
	inline: -database=$build_databasealias, -maxrecords='all', -sql='DESCRIBE `' + $build_databasename + '`.`' + $build_tablename + '`';
		records;
			var: 'rawtype' = (string_uppercase: (field: 'type'));
			var: 'type' = $rawtype;
			var: 'param' = '';
			var: 'precision' = '';

			if: ($rawtype >> '(');
				var: 'param' = (string_replaceregexp: $rawtype, -find='([^(]+)\\(([^)]+)\\).*', -replace='\\2');
				var: 'type'  = (string_replaceregexp: $rawtype, -find='([^(]+)\\(([^)]+)\\).*', -replace='\\1');
			else: ($rawtype >> ' ');
				var: 'type'  = (string_replaceregexp: $rawtype, -find='([^ ]+) .*', -replace='\\1');
			/if;

			if: ($type >> 'FLOAT') || ($type >> 'DECIMAL') || ($type >> 'DOUBLE');
				if: $param >> ',';
					var: 'precision' = (string_replaceregexp: $param, -find='([^,]+),(.+)', -replace='\\2');
					var: 'param'  = (string_replaceregexp: $param, -find='([^,]+),(.+)', -replace='\\1');
				/if;
			/if;

			loop: $build_fieldmap->size;
				var: 'id' = $build_fieldmap->(get:loop_count)->first;
				var: 'temp' = $build_fieldmap->(get:loop_count)->second;
				if: $temp->(find: 'name') == (field: 'field');
					$temp->(insert: 'rawtype'=$rawtype);
					$temp->(insert: 'type'= $type);
					$temp->(insert: 'param'= $param);
					$temp->(insert: 'precision'= $precision);
					if: (field: 'null') == 'YES';
						$temp->(insert: 'allownull'='Yes');
					else;
						$temp->(insert: 'allownull'='No');
					/if;
					if: (field: 'rawtype') >> 'BINARY';
						$temp->(insert: 'casesensitive'='Yes');
					/if;
					if: (field: 'rawtype') >> 'UNSIGNED';
						$temp->(insert: 'unsigned'='Yes');
					/if;
					$build_fieldmap->(get: loop_count) = (pair: $id=$temp);
				//	loop_abort;
				/if;
			/loop;

		/records;
	/inline;
/if;

var: 'build_fielddetail' = $build_fieldmap->(find: $build_fieldid);


//
// Construct Index Map
//

var: 'build_indexmap' = array;
var: 'build_indexfields' = (map);

if: (var:'build_databasealias') && (var:'build_databasename') && (var:'build_tablename');
	inline: -database=$build_databasealias, -maxrecords='all', -sql='SHOW INDEX FROM `' + $build_databasename + '`.`' + $build_tablename + '`';
		records;
			var: 'temp' = (map);
			loop: (field_name: -count);
				$temp->(insert: (field_name: loop_count) = (field: (field_name: loop_count)));
			/loop;
			$build_indexmap->(insert: (field: 'key_name') = $temp);

			if: $build_indexfields->(find: (field: 'key_name')) == null;
				$build_indexfields->(insert: (field: 'key_name') = (field: 'column_name'));
			else;
				$build_indexfields->(insert: (field: 'key_name') = $build_indexfields->(find: (field: 'key_name')) + ', ' + (field: 'column_name'));
			/if;
		/records;
	/inline;

/if;

if: ($build_indexmap == null) || ($build_indexmap->size == 0);
	var: 'build_indexid' = 0;
else: ($build_indexmap->(find: $build_indexid) == (array));
	var: 'build_indexid' = $build_indexmap->(get:1)->first;
/if;

if: (!var_defined: 'build_indexdetail');
	var: 'build_indexdetail' = $build_indexmap->(find: $build_indexid);
/if;

//output: '<br><font size="1" face="verdana" color="gray">' + $build_indexdetail + '</font>', -encodenone;

//output: '<font size="1" color="green" face="verdana">' + $build_fieldmap + '</font><br>', -encodenone;
//output: '<font size="1" color="red" face="verdana">' + $build_fielddetail + '</font><br>', -encodenone;

//
// Process Navigation
//

if: $build_navigation >> 'Prev';
	$build_index_skip -= 10;
else: $build_navigation >> 'Next';
	$build_index_skip += 10;
else: $build_navigation >> 'First';
	$build_index_skip = 1;
else: $build_navigation >> 'Last';
	$build_index_skip = $build_fieldmap->size - (($build_fieldmap->size - 1) % 10);
else: $build_navigation >> 'Jump';
	$build_index_skip = integer: $build_jump;
/if;

var: 'found_count' = $build_indexmap->size;
var: 'build_index_skip' = integer: (math_max: 1, (math_min: $build_index_skip, $found_count));
var: 'shown_first' = $build_index_skip;
var: 'shown_last' = integer: (math_min: $found_count, $build_index_skip + 9);
var: 'shown_count' = ($shown_last - $shown_first + 1);

?>
