<?LassoScript
// Define tags for use below.

	include: (lassoapp_link: 'tags.lasso');

// Start the session

if: (form_param:'logout') == 'true';

	session_end: -name='_groupadmin';
	redirect_url:'logout.lasso';

else;
	session_start: -name='_groupadmin', -expires=120, -uselink;
	session_addvar: -name='_groupadmin', 'admin_username';
	session_addvar: -name='_groupadmin', 'admin_datetime';
/if;

// Test the session
var: 'admin_username'=(client_username);
if: (var_defined:'admin_datetime' == false) || (var: 'admin_datetime') == '';
	var: 'admin_datetime'=(date);
/if;


// Set up the Tab Environment

encode_set: -encodenone;

if:(var_defined:'admin_path')==false;
	var:'admin_path'='';
/if;

if:(var_defined:'admin_file')==false;
	var:'admin_file'=(LassoApp_Link: 'default.lasso');
/if;

if:(var_defined:'admin_pane')==false;
	var:'admin_pane'=(LassoApp_Link: 'default.lasso');
/if;

var: 'tab1_enabled'='#999999';
var: 'tab1_enabled_right'=(LassoApp_Link: 'images/tab1_enabled_right.gif');
var: 'tab1_enabled_left'=(LassoApp_Link: 'images/tab1_enabled_left.gif');
var: 'tab1_disabled'='#CCCCCC';
var: 'tab1_disabled_right'=(LassoApp_Link: 'images/tab1_disabled_right.gif');
var: 'tab1_disabled_left'=(LassoApp_Link: 'images/tab1_disabled_left.gif');

var: 'tab2_enabled'='#EEEEEE';
var: 'tab2_enabled_right'=(LassoApp_Link: 'images/tab2_enabled_right.gif');
var: 'tab2_enabled_left'=(LassoApp_Link: 'images/tab2_enabled_left.gif');
var: 'tab2_disabled'='#999999';
var: 'tab2_disabled_right'='';
var: 'tab2_disabled_left'='';

var:'admin_tab1'=(form_param:'tab1');
var:'admin_tab2'=(form_param:'tab2');
var:'admin_tab3'=(form_param:'tab3');

if:(var:'admin_tab1')=='';
	var:'admin_tab1'='setup';
/if;
?>

<?LassoScript
if: (var_defined:'admin_tab1_array')==false;
var:'admin_tab1_array'=(array:
	(map:
		'name'='setup',
		'label'='Group Administration',
		'color'=$tab1_disabled,
		'active'=true,
		'default'='users',
		'tab2_array'=(array:
			(map:
				'name'='users',
				'label'='Users',
				'color'=$tab2_disabled,
				'active'=true,
				'format'=(LassoApp_Link: 'setup/users/default.lasso'),
				'library'=(LassoApp_Link: 'setup/users/library.lasso')
			),(map:
				'name'='adduser',
				'label'='Add User',
				'color'=$tab2_disabled,
				'active'=true,
				'format'=(LassoApp_Link: 'setup/adduser/default.lasso'),
				'library'=(LassoApp_Link: 'setup/adduser/library.lasso')
			)
		)
	)
);

/if;

// Set up the default tab positions

loop:(var:'admin_tab1_array')->(size);
	if:(var:'admin_tab1_array')->(get:loop_count)->(find:'name')==(var:'admin_tab1');
		var:'admin_tab1_label'=(var:'admin_tab1_array')->(get:loop_count)->(find:'label');
		var:'admin_librarypath1'=(var:'admin_tab1_array')->(get:loop_count)->(find:'library');

		(var:'admin_tab1_array')->(get:loop_count)->(insert:'color'=$tab1_enabled);
		(var:'admin_tab1_array')->(get:loop_count)->(insert:'right'=$tab1_enabled_right);
		(var:'admin_tab1_array')->(get:loop_count)->(insert:'left'=$tab1_enabled_left);
		var:'admin_tab2_array'=(var:'admin_tab1_array')->(get:loop_count)->(find:'tab2_array');
		if:(var:'admin_tab2')=='';
			var:'admin_tab2'=(var:'admin_tab1_array')->(get:loop_count)->(find:'default');
		/if;
	else;
		(var:'admin_tab1_array')->(get:loop_count)->(insert:'color'=$tab1_disabled);
		(var:'admin_tab1_array')->(get:loop_count)->(insert:'right'=$tab1_disabled_right);
		(var:'admin_tab1_array')->(get:loop_count)->(insert:'left'=$tab1_disabled_left);
	/if;
/loop;

if:(var:'admin_tab2_array')==null;
	(var:'admin_tab2_array')=(var:'admin_tab1_array')->(get:1)->(find:'tab2_array');
/if;

loop:(var:'admin_tab2_array')->(size);
	if:(var:'admin_tab2_array')->(get:loop_count)->(find:'name')==(var:'admin_tab2');
		var:'admin_tab2_label'=(var:'admin_tab2_array')->(get:loop_count)->(find:'label');
		var:'admin_librarypath'=(var:'admin_tab2_array')->(get:loop_count)->(find:'library');
		var:'admin_panepath'=(var:'admin_tab2_array')->(get:loop_count)->(find:'format');

		(var:'admin_tab2_array')->(get:loop_count)->(insert:'color'=$tab2_enabled);
		(var:'admin_tab2_array')->(get:loop_count)->(insert:'right'=$tab2_enabled_right);
		(var:'admin_tab2_array')->(get:loop_count)->(insert:'left'=$tab2_enabled_left);
	else;
		(var:'admin_tab2_array')->(get:loop_count)->(insert:'color'=$tab2_disabled);
		(var:'admin_tab2_array')->(get:loop_count)->(insert:'right'=$tab2_disabled_right);
		(var:'admin_tab2_array')->(get:loop_count)->(insert:'left'=$tab2_disabled_left);
	/if;
/loop;

/encode_set;

?>

[if: $admin_librarypath1 != null]
[html_comment] Global Library [var: 'admin_librarypath1'] [/html_comment]
[include: $admin_librarypath1]
[html_comment] /Global Library [var: 'admin_librarypath1'] [/html_comment]
[/if][if: $admin_librarypath != null]
[html_comment] Library [var: 'admin_librarypath'] [/html_comment]
[include: $admin_librarypath]
[html_comment] /Library [var: 'admin_librarypath'] [/html_comment]
[/if]
