<?LassoScript
//
// Store Search Variables in Session
//

session_addvar: -name='_reference', 'detail_maxrecords';
session_addvar: -name='_reference', 'detail_skiprecords';
session_addvar: -name='_reference', 'detail_found_count';
session_addvar: -name='_reference', 'detail_mode';
session_addvar: -name='_reference', 'detail_index';

variable_default: 'detail_mode', 'default';
variable_default: 'detail_skiprecords', 0;

//
// Base Inline
//

variable: 'detail_inline' = (array);

//
// Search Parameters
//

if: ($detail_mode >> 'search') && (var_defined: 'search_inline') && (var_defined: 'detail_skiprecords');
	variable: 'detail_inline' = $search_inline;
	variable: 'detail_index' = '';
else: ($detail_mode >> 'advanced') && (var_defined: 'advanced_inline') && (var_defined: 'detail_skiprecords');
	variable: 'detail_inline' = $advanced_inline;
	variable: 'detail_index' = '';
else: ($detail_mode >> 'browse_category') && (var_defined: 'browse_category_inline') && (var_defined: 'detail_skiprecords');
	variable: 'detail_inline' = $browse_category_inline;
	variable: 'detail_index' = '';
else: ($detail_mode >> 'browse_legacy') && (var_defined: 'browse_legacy_inline') && (var_defined: 'detail_skiprecords');
	variable: 'detail_inline' = $browse_legacy_inline;
	variable: 'detail_index' = '';
else: ($detail_mode >> 'list_category') && (var_defined: 'list_category_inline') && (var_defined: 'detail_skiprecords');
	variable: 'detail_inline' = $list_category_inline;
	variable: 'detail_index' = '';
else: ($detail_mode >> 'list_legacy') && (var_defined: 'list_legacy_inline') && (var_defined: 'detail_skiprecords');
	variable: 'detail_inline' = $list_legacy_inline;
	variable: 'detail_index' = '';
else: ($detail_mode >> 'list_all') && (var_defined: 'list_all_inline') && (var_defined: 'detail_skiprecords');
	variable: 'detail_inline' = $list_all_inline;
	variable: 'detail_index' = '';
else: ($detail_mode >> 'detail_related') && (var_defined: 'detail_index');
	variable: 'detail_inline' = $ref_tag_inline;
	$detail_inline->(insert: -search='');
	$detail_inline->(insert: -op='eq');
	$detail_inline->(insert: $ref_tag_index=(var: 'detail_index'));
	$detail_skiprecords=0;
else;
	variable: 'detail_inline' = $ref_tag_inline;
	$detail_inline->(insert: -search='');
	$detail_inline->(insert: $ref_tag_basic='Y');
	$detail_inline->(insert: -SortField=$ref_tag_name);
/if;

if: (var: 'detail_inline')->type != 'array';
	var: 'detail_inline' = $ref_tag_inline;
/if;

$detail_inline->(insert: -maxrecords=1);

//
// Navigation Parameters
//

if: (var_defined: 'detail_navigation') && (var_defined: 'detail_found_count') && (var_defined: 'detail_skiprecords') && (var_defined: 'detail_maxrecords');
	if: ($detail_navigation >> 'Prev');
		var: 'temp' = (math_min: $detail_found_count, (math_max: 0, (math_sub: $detail_skiprecords, $detail_maxrecords)));
		$detail_inline->(insert: -SkipRecords=$temp);
	else: ($detail_navigation >> 'Next');
		var: 'temp' = (math_min: $detail_found_count, (math_max: 0, (math_add: $detail_skiprecords, $detail_maxrecords)));
		$detail_inline->(insert: -SkipRecords=$temp);
	/if;
else;
	$detail_inline->(insert: -SkipRecords=$detail_skiprecords);
/if;

//
// Perform the Search
//

var: 'valid_search' = true;

inline: $detail_inline, -inlinename='detail_results';
	var: 'detail_found_count' = (found_count);
	var: 'detail_shown_count' = (shown_count);
	var: 'detail_shown_first' = (shown_first);
	var: 'detail_shown_last' = (shown_last);
	var: 'detail_maxrecords' = (maxrecords_value);
	var: 'detail_skiprecords' = (skiprecords_value);

	if: (var_defined: 'detail_tag') && ($detail_tag != (field: $ref_tag_index));
		var: 'valid_search' = false;
	/if;
/inline;

if: ($valid_search == false);
	variable: 'detail_inline' = $ref_tag_inline;
	$detail_inline->(insert: -search='');
	$detail_inline->(insert: -op='eq');
	$detail_inline->(insert: $ref_tag_index=(var: 'detail_tag'));
	$detail_skiprecords=0;

	inline: $detail_inline, -inlinename='detail_results';
		var: 'detail_found_count' = (found_count);
		var: 'detail_shown_count' = (shown_count);
		var: 'detail_shown_first' = (shown_first);
		var: 'detail_shown_last' = (shown_last);
		var: 'detail_maxrecords' = (maxrecords_value);
		var: 'detail_skiprecords' = (skiprecords_value);
	/inline;
	
/if;

?>

<?LassoScript
//
// LassoScript for Comments
//

//
// Store Search Variables in Session
//

session_addvar: -name='_reference', 'comments_tag_index';
session_addvar: -name='_reference', 'comments_maxrecords';
session_addvar: -name='_reference', 'comments_skiprecords';
session_addvar: -name='_reference', 'comments_detail_skiprecords';
session_addvar: -name='_reference', 'comments_found_count';
session_addvar: -name='_reference', 'comments_mode';
session_addvar: -name='_reference', 'comments_author';
session_addvar: -name='_reference', 'comments_email';

variable_default: 'comments_mode', 'default';
variable_default: 'comments_skiprecords', 0;
variable_default: 'comments_detail_skiprecords', 0;
variable_default: 'comments_detail_found_count', 0;
variable_default: 'comments_tag_index', (-1);

//
// Set the Tag Index
//

records: -inlinename='detail_results';
	if: ((var: 'comments_tag_index') != (field: $ref_tag_index));
		var: 'comments_skiprecords'=0;
		var: 'comments_detail_skiprecords'='';
	/if;
	var: 'comments_tag_index'=(field: $ref_tag_index);
	var: 'comments_tag_name'=(field: $ref_tag_name);
/records;

//
// Perform Add if Necessary
//

if: (var: 'comments_mode') >> 'Add';
	variable: 'comments_inline' = $ref_comments_inline;
	$comments_inline->(insert: -add='');
	$comments_inline->(insert: $ref_comments_tag_index=$comments_tag_index);
	$comments_inline->(insert: $ref_comments_tag_name=$comments_tag_name);
	$comments_inline->(insert: $ref_comments_datetime=(date));
	if: (var: 'comments_author') != '';
		$comments_inline->(insert: $ref_comments_author=(var: 'comments_author'));
	else;
		var: 'comments_mode' = 'error';
	/if;
	if: (var: 'comments_email') != '';
		$comments_inline->(insert: $ref_comments_email=(var: 'comments_email'));
	else;
		var: 'comments_mode' = 'error';
	/if;
	if: (var: 'comments_subject') != '';
		$comments_inline->(insert: $ref_comments_subject=(var: 'comments_subject'));
	else;
		var: 'comments_mode' = 'error';
	/if;
	if: (var: 'comments_body') != '';
		$comments_inline->(insert: $ref_comments_comments=(var: 'comments_body'));
	else;
		var: 'comments_mode' = 'error';
	/if;

	if: (var:'comments_mode') != 'error';
		inline: $comments_inline;
			var: 'comments_detail_index'=(keyfield_value);
		/inline;
		var:'comments_mode'='default';
	/if;
/if;

//
// Base Inline
//

variable: 'comments_inline' = $ref_comments_inline;
$comments_inline->(insert: -search='');
$comments_inline->(insert: -maxrecords=10);
$comments_inline->(insert: -op='eq');
$comments_inline->(insert: $ref_comments_tag_index=$comments_tag_index);
$comments_inline->(insert: -sortfield=$ref_comments_timestamp);
$comments_inline->(insert: -sortorder='descending');

//
// Navigation Parameters
//

if: (var_defined: 'comments_navigation') && (var_defined: 'comments_found_count') && (var_defined: 'comments_skiprecords') && (var_defined: 'comments_maxrecords');
	if: ($comments_navigation >> 'Prev');
		var: 'temp' = (math_min: $comments_found_count, (math_max: 0, (math_sub: $comments_skiprecords, $comments_maxrecords)));
		$comments_inline->(insert: -SkipRecords=$temp);
	else: ($comments_navigation >> 'Next');
		var: 'temp' = (math_min: $comments_found_count, (math_max: 0, (math_add: $comments_skiprecords, $comments_maxrecords)));
		$comments_inline->(insert: -SkipRecords=$temp);
	/if;
else;
	$comments_inline->(insert: -SkipRecords=$comments_skiprecords);
/if;

//
// Perform the Search
//

inline: $comments_inline, -inlinename='comments_results';
	var: 'comments_found_count' = (found_count);
	var: 'comments_shown_count' = (shown_count);
	var: 'comments_shown_first' = (shown_first);
	var: 'comments_shown_last' = (shown_last);
	var: 'comments_maxrecords' = (maxrecords_value);
	var: 'comments_skiprecords' = (skiprecords_value);
/inline;

//
// Check for a Detail Link
//

if: (var: 'comments_found_count') > 0;

	if: (var: 'comments_detail_skiprecords') == '';
		var: 'comments_detail_skiprecords'=0;
	/if;

	variable: 'comments_inline' = $ref_comments_inline;
	$comments_inline->(insert: -search='');
	$comments_inline->(insert: -maxrecords=1);

	if: (var: 'comments_detail_index') != '';
		$comments_inline->(insert: -op='eq');
		$comments_inline->(insert: 'id'=$comments_detail_index);
	else;
		$comments_inline->(insert: -op='eq');
		$comments_inline->(insert: $ref_comments_tag_index=$comments_tag_index);
		$comments_inline->(insert: -sortfield=$ref_comments_timestamp);
		$comments_inline->(insert: -sortorder='descending');
		$comments_inline->(insert: -skiprecords=$comments_detail_skiprecords);
	/if;

	inline: $comments_inline, -inlinename='comments_detail_results';
		var: 'comments_detail_found_count' = (found_count);
	/inline;
/if;

?>


