<?LassoScript

	/*
		Table Rename

		This code will recase the tables in the site table so that we are all lowercase.

	*/

	protect;

		inline:
			-database = 'lasso_internal',
			-sql = '\
				select \
					a.id as id, \
					a.name as name \
				from \
					security_database_tables as a \
					left join security_datasource_databases as b on a.id_database = b.id \
					left join security_datasources as c on b.id_datasource = c.id \
				where \
					c.name = \'InternalMySQLDS\' and \
					b.name = \'site\' and \
					a.name like \'\\_%\'\
			';

			if: error_code != 0;
				log_critical: error_code ': ' error_msg;
			/if;

			local: 'update' = array;

			records;
				if: (bytes: (field: 'name')) == '_Maintenance';
					#update->(insert: (field: 'id') = '_maintenance');
				else: (bytes: (field: 'name')) == '_OutgoingEmail';
					#update->(insert: (field: 'id') = '_outgoingemail');
				else: (bytes: (field: 'name')) == '_OutgoingEmailPrefs';
					#update->(insert: (field: 'id') = '_outgoingemailprefs');
				else: (bytes: (field: 'name')) == '_Schedule';
					#update->(insert: (field: 'id') = '_schedule');
				/if;
			/records;

			if: #update->size;

				log_warning: 'Updating the case of the site tables';

				iterate: #update, local('i');

					inline:
						-database = 'lasso_internal',
						-table = 'security_database_tables',
						-keyfield = 'id',
						-keyvalue = #i->first,
						'name' = #i->second,
						-update;

						if: error_code != 0;
							log_critical: error_code ': ' error_msg;
						/if;

					/inline;

				/iterate;

				if: #update->size;
					Admin_RefreshSecurity;
					Admin_ReloadDatasource: 'InternalMySQLDS';
				/if;

			/if;

		/inline;

		handle_error;
			log_critical: error_code ': ' error_msg;
		/handle_error;

	/protect;

?>